---
title: Complex Questions in Expressions
product: Form Library
description: Learn how to access values of individual items in multiple textboxes or specific matrix cells and use them in expressions, form branching, and visibility rules for any follow-up questions. Try out a live JavaScript form builder demo with a step-by-step implementation guide.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Complex Questions in Expressions (Vanilla JS)

Complex questions can contain more than one value. Such questions include Single-, Multi-Select, and Dynamic Matrices, Dynamic Panels, and Multiple Textboxes questions. This example demonstrates how to access different values within complex questions.

To access a value from outside a complex question, use the question's name and the name of its element (item, row, column) to which the value belongs:

<div class="v2-class---doc-table-container">
  <table class="v2-class---doc-table-container__table">
    <thead>
      <tr>
        <th>Question Type</th>
        <th>Syntax</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <td><a href="/form-library/documentation/api-reference/multiple-text-entry-question-model">Multiple Textboxes</a></td>
        <td><code>{questionname.itemname}</code></td>
      </tr>
      <tr>
        <td><a href="/form-library/documentation/api-reference/matrix-table-question-model">Single-Select Matrix</a></td>
        <td><code>{questionname.rowname}</code></td>
      </tr>
      <tr>
        <td rowspan="2" style="vertical-align:middle"><a href="/form-library/documentation/api-reference/matrix-table-with-dropdown-list">Multi-Select Matrix</a></td>
        <td><code>{questionname.rowname.columnname}</code></td>
      </tr>
      <tr>
        <td><code>{questionname-total.columnname}</code> (accesses a cell in the total row)</td>
      </tr>
    </tbody>
  </table>
</div>

This demo shows a [Multiple Textboxes](/form-library/documentation/api-reference/multiple-text-entry-question-model) question that asks users to enter contact details, including an email address. Under this question, the form displays an "I agree to receive newsletters" checkbox, which is visible only if an email address is provided. This checkbox is a [Yes/No (Boolean)](/form-library/documentation/api-reference/boolean-question-model) question. Its [`visibleIf`](/form-library/documentation/api-reference/boolean-question-model#visibleIf) expression accesses the email address input field of the Multiple Textboxes question using the notation from the table above.

To access a value (question or cell) within a [Dynamic Panel](/form-library/documentation/api-reference/dynamic-panel-model) or [Dynamic Matrix](/form-library/documentation/api-reference/dynamic-matrix-table-question-model) from outside, use a zero-based index:

| Question Type                                                          | Syntax                                     |
| ---------------------------------------------------------------------- | ------------------------------------------ |
| [Dynamic Panel](/form-library/documentation/api-reference/dynamic-panel-model)   | `{dynamicpanelname[index].questionname}`   |
| [Dynamic Matrix](/form-library/documentation/api-reference/dynamic-matrix-table-question-model) | `{dynamicmatrixname[rowindex].columnname}` |

To access a cell or question from inside a matrix, panel, or composite question, use the `row`, `panel`, `parentPanel`, and `composite` prefixes:

<div class="v2-class---doc-table-container">
  <table class="v2-class---doc-table-container__table">
    <thead>
      <tr>
        <th>Question Type</th>
        <th>Syntax</th>
        <th>Action</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <td rowspan="3" style="vertical-align:middle"><a href="/form-library/documentation/api-reference/matrix-table-question-model">Single-Select Matrix</a>, <a href="/form-library/documentation/api-reference/matrix-table-with-dropdown-list">Multi-Select Matrix</a>, <a href="/form-library/documentation/api-reference/dynamic-matrix-table-question-model">Dynamic Matrix</a></td>
        <td><code>{row.columnname}</code></td>
        <td>Accesses a cell in the same row.</td>
      </tr>
      <tr>
        <td style="vertical-align:middle"><code>{rowName}</code></td>
        <td>Accesses the row name (the <code>value</code> property within objects in the <a href="https://surveyjs.io/form-library/documentation/api-reference/matrix-table-with-dropdown-list#rows"><code>rows</code></a> array). Use this placeholder if you need to distinguish between matrix rows.</td>
      </tr>
      <tr>
        <td style="vertical-align:middle"><code>{rowTitle}</code></td>
        <td>Accesses the row title (the <code>text</code> property within objects in the <a href="https://surveyjs.io/form-library/documentation/api-reference/matrix-table-with-dropdown-list#rows"><code>rows</code></a> array).</td>
      </tr>
      <tr>
        <td rowspan="2" style="vertical-align:middle"><a href="/form-library/documentation/api-reference/dynamic-panel-model">Dynamic Panel</a></td>
        <td><code>{panel.questionname}</code></td>
        <td>Accesses a question within the same panel.</td>
      </tr>
      <tr>
        <td style="vertical-align:middle"><code>{parentPanel.questionname}</code></td>
        <td>Accesses a question within a parent Dynamic Panel.<br>Applies when one Dynamic Panel question is nested in another.</td>
      </tr>
      <tr>
        <td><a href="/form-library/documentation/customize-question-types/create-composite-question-types">Composite questions</a></td>
        <td><code>{composite.questionname}</code></td>
        <td>Accesses a question within the same composite question.</td>
      </tr>
    </tbody>
  </table>
</div>

In this demo, the `row` prefix is used to calculate totals in each matrix row and enable or disable the Quantity column cells based on a condition. Refer to the `json.js` file for code examples.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { Serializer, registerFunction } from "survey-core";

// Add the `price` property to choice options
Serializer.addProperty("itemvalue", "price:number");

// A custom function that returns a selected item's price
const getItemPrice = function (params) {
    // `this.row` is available only within matrix cells
    const question = this.row ? this.row.getQuestionByColumnName(params[0]) : null;
    if (!question) return 0;
    const selectedItem = question.selectedItem;
    // Return 0 if a user haven't selected an item yet
    return selectedItem ? selectedItem.price : 0;
};
registerFunction({ name: "getItemPrice", func: getItemPrice });

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
survey.data = {
    "orders": [{
        "id": 1,
        "phoneModel": "iPhone15ProMax-1024",
        "quantity": 1,
    }, {
        "id": 2,
        "phoneModel": "iPhone15-256",
        "quantity": 2,
    }, {
        "id": 3,
        "phoneModel": "iPhone14Pro-512",
        "quantity": 2,
    }],
    "subscribed": true
};

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "calculatedValues": [
    {
      "name": "totalExpr",
      "expression": "sumInArray({orders}, 'total')"
    },
    {
      "name": "10%DiscountExpr",
      "expression": "{totalExpr} - ({totalExpr} * 0.1)"
    },
    {
      "name": "15%DiscountExpr",
      "expression": "{totalExpr} - ({totalExpr} * 0.15)"
    },
    {
      "name": "20%DiscountExpr",
      "expression": "{totalExpr} - ({totalExpr} * 0.2)"
    }
  ],
  "elements": [
    {
      "type": "matrixdynamic",
      "name": "orders",
      "minRowCount": 1,
      "titleLocation": "hidden",
      "addRowText": "Add new item",
      "columns": [
        {
          "name": "id",
          "title": "Id",
          "cellType": "expression",
          "expression": "{rowIndex}",
          "visible": false
        },
        {
          "name": "phoneModel",
          "title": "Phone model",
          "isRequired": true,
          "cellType": "dropdown",
          "choices": [
            { "text": "iPhone 15 Pro Max, 256GB", "value": "iPhone15ProMax-256", "price": 1199 },
            { "text": "iPhone 15 Pro Max, 512GB", "value": "iPhone15ProMax-512", "price": 1399 },
            { "text": "iPhone 15 Pro Max, 1TB", "value": "iPhone15ProMax-1024", "price": 1599 },
            { "text": "iPhone 15 Pro, 128GB", "value": "iPhone15Pro-128", "price": 999 },
            { "text": "iPhone 15 Pro, 256GB", "value": "iPhone15Pro-256", "price": 1099 },
            { "text": "iPhone 15 Pro, 512GB", "value": "iPhone15Pro-512", "price": 1299 },
            { "text": "iPhone 15 Pro, 1TB", "value": "iPhone15Pro-1024", "price": 1499 },
            { "text": "iPhone 15 Plus, 128GB", "value": "iPhone15Plus-128", "price": 899 },
            { "text": "iPhone 15 Plus, 256GB", "value": "iPhone15Plus-256", "price": 999 },
            { "text": "iPhone 15 Plus, 512GB", "value": "iPhone15Plus-512", "price": 1199 },
            { "text": "iPhone 15, 128GB", "value": "iPhone15-128", "price": 799 },
            { "text": "iPhone 15, 256GB", "value": "iPhone15-256", "price": 899 },
            { "text": "iPhone 15, 512GB", "value": "iPhone15-512", "price": 1099 },
            { "text": "iPhone 14 Pro Max, 256GB", "value": "iPhone14ProMax-256", "price": 1099 },
            { "text": "iPhone 14 Pro Max, 512GB", "value": "iPhone14ProMax-512", "price": 1299 },
            { "text": "iPhone 14 Pro Max, 1TB", "value": "iPhone14ProMax-1024", "price": 1499 },
            { "text": "iPhone 14 Pro, 128GB", "value": "iPhone14Pro-128", "price": 899 },
            { "text": "iPhone 14 Pro, 256GB", "value": "iPhone14Pro-256", "price": 999 },
            { "text": "iPhone 14 Pro, 512GB", "value": "iPhone14Pro-512", "price": 1199 },
            { "text": "iPhone 14 Pro, 1TB", "value": "iPhone14Pro-1024", "price": 1399 },
            { "text": "iPhone 14 Plus, 128GB", "value": "iPhone14Plus-128", "price": 799 },
            { "text": "iPhone 14 Plus, 256GB", "value": "iPhone14Plus-256", "price": 899 },
            { "text": "iPhone 14 Plus, 512GB", "value": "iPhone14Plus-512", "price": 1099 },
            { "text": "iPhone 14, 128GB", "value": "iPhone14-128", "price": 699 },
            { "text": "iPhone 14, 256GB", "value": "iPhone14-256", "price": 799 },
            { "text": "iPhone 14, 512GB", "value": "iPhone14-512", "price": 999 }
          ]
        },
        {
          "name": "price",
          "title": "Price",
          "cellType": "expression",
          "expression": "getItemPrice('phoneModel')",
          "displayStyle": "currency"
        },
        {
          "name": "quantity",
          "title": "Quantity",
          "isRequired": true,
          "cellType": "text",
          "inputType": "number",
          "min": 1,
          "max": 100,
          "defaultValue": 1,
          "textUpdateMode": "onTyping",
          "enableIf": "{row.phoneModel} notempty"
        },
        {
          "name": "total",
          "title": "Total",
          "cellType": "expression",
          "expression": "{row.quantity} * {row.price}",
          "displayStyle": "currency"
        }
      ]
    },
    {
      "type": "html",
      "name": "totalHtml",
      "html": "<p style=\"text-align:right\"><b>Total: <ins>${totalExpr}</ins></b></p>",
      "visibleIf": "{totalExpr} < 3000"
    },
    {
      "type": "html",
      "name": "10%DiscountHtml",
      "html": "<p style=\"text-align:right\"><b>Total: <del>${totalExpr}</del> <ins>${10%DiscountExpr}</ins></b> (-10%)</p>",
      "visibleIf": "{totalExpr} >= 3000 and {totalExpr} < 5000"
    },
    {
      "type": "html",
      "name": "15%DiscountHtml",
      "html": "<p style=\"text-align:right\"><b>Total: <del>${totalExpr}</del> <ins>${15%DiscountExpr}</ins></b> (-15%)</p>",
      "visibleIf": "{totalExpr} >= 5000 and {totalExpr} < 7000"
    },
    {
      "type": "html",
      "name": "20%DiscountHtml",
      "html": "<p style=\"text-align:right\"><b>Total: <del>${totalExpr}</del> <ins>${20%DiscountExpr}</ins></b> (-20%)</p>",
      "visibleIf": "{totalExpr} >= 7000"
    },
    {
      "type": "multipletext",
      "name": "contactDetails",
      "title": "Enter contact details",
      "items": [
        { "name": "name", "title": "Full name", "isRequired": true },
        { "name": "address", "title": "Shipping address", "isRequired": true },
        { "name": "phone", "title": "Phone", "isRequired": true },
        { "name": "email", "title": "Email", "isRequired": true, "validators": [{ "type": "email" }] }
      ],
      "itemTitleWidth": "90px",
      "visibleIf": "sumInArray({orders}, 'total') > 0"
    },
    {
      "type": "boolean",
      "name": "subscribed",
      "displayMode": "checkbox",
      "title": "I agree to receive weekly newsletters",
      "defaultValue": true,
      "visibleIf": "{contactDetails.email} notempty"
    }
  ],
  "completedHtml": "<h4>Thank you for your order!</h4><p>Your order will be shipped within 5 days. We'll send you an email with order details shortly.</p>"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/angular.md)
- [React](https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/jquery.md)


---
title: Complex Questions in Expressions
product: Form Library
description: Learn how to access values of individual items in multiple textboxes or specific matrix cells and use them in expressions, form branching, and visibility rules for any follow-up questions. Try out a live JavaScript form builder demo with a step-by-step implementation guide.
framework: Angular
source: https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Complex Questions in Expressions (Angular)

Complex questions can contain more than one value. Such questions include Single-, Multi-Select, and Dynamic Matrices, Dynamic Panels, and Multiple Textboxes questions. This example demonstrates how to access different values within complex questions.

To access a value from outside a complex question, use the question's name and the name of its element (item, row, column) to which the value belongs:

<div class="v2-class---doc-table-container">
  <table class="v2-class---doc-table-container__table">
    <thead>
      <tr>
        <th>Question Type</th>
        <th>Syntax</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <td><a href="/form-library/documentation/api-reference/multiple-text-entry-question-model">Multiple Textboxes</a></td>
        <td><code>{questionname.itemname}</code></td>
      </tr>
      <tr>
        <td><a href="/form-library/documentation/api-reference/matrix-table-question-model">Single-Select Matrix</a></td>
        <td><code>{questionname.rowname}</code></td>
      </tr>
      <tr>
        <td rowspan="2" style="vertical-align:middle"><a href="/form-library/documentation/api-reference/matrix-table-with-dropdown-list">Multi-Select Matrix</a></td>
        <td><code>{questionname.rowname.columnname}</code></td>
      </tr>
      <tr>
        <td><code>{questionname-total.columnname}</code> (accesses a cell in the total row)</td>
      </tr>
    </tbody>
  </table>
</div>

This demo shows a [Multiple Textboxes](/form-library/documentation/api-reference/multiple-text-entry-question-model) question that asks users to enter contact details, including an email address. Under this question, the form displays an "I agree to receive newsletters" checkbox, which is visible only if an email address is provided. This checkbox is a [Yes/No (Boolean)](/form-library/documentation/api-reference/boolean-question-model) question. Its [`visibleIf`](/form-library/documentation/api-reference/boolean-question-model#visibleIf) expression accesses the email address input field of the Multiple Textboxes question using the notation from the table above.

To access a value (question or cell) within a [Dynamic Panel](/form-library/documentation/api-reference/dynamic-panel-model) or [Dynamic Matrix](/form-library/documentation/api-reference/dynamic-matrix-table-question-model) from outside, use a zero-based index:

| Question Type                                                          | Syntax                                     |
| ---------------------------------------------------------------------- | ------------------------------------------ |
| [Dynamic Panel](/form-library/documentation/api-reference/dynamic-panel-model)   | `{dynamicpanelname[index].questionname}`   |
| [Dynamic Matrix](/form-library/documentation/api-reference/dynamic-matrix-table-question-model) | `{dynamicmatrixname[rowindex].columnname}` |

To access a cell or question from inside a matrix, panel, or composite question, use the `row`, `panel`, `parentPanel`, and `composite` prefixes:

<div class="v2-class---doc-table-container">
  <table class="v2-class---doc-table-container__table">
    <thead>
      <tr>
        <th>Question Type</th>
        <th>Syntax</th>
        <th>Action</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <td rowspan="3" style="vertical-align:middle"><a href="/form-library/documentation/api-reference/matrix-table-question-model">Single-Select Matrix</a>, <a href="/form-library/documentation/api-reference/matrix-table-with-dropdown-list">Multi-Select Matrix</a>, <a href="/form-library/documentation/api-reference/dynamic-matrix-table-question-model">Dynamic Matrix</a></td>
        <td><code>{row.columnname}</code></td>
        <td>Accesses a cell in the same row.</td>
      </tr>
      <tr>
        <td style="vertical-align:middle"><code>{rowName}</code></td>
        <td>Accesses the row name (the <code>value</code> property within objects in the <a href="https://surveyjs.io/form-library/documentation/api-reference/matrix-table-with-dropdown-list#rows"><code>rows</code></a> array). Use this placeholder if you need to distinguish between matrix rows.</td>
      </tr>
      <tr>
        <td style="vertical-align:middle"><code>{rowTitle}</code></td>
        <td>Accesses the row title (the <code>text</code> property within objects in the <a href="https://surveyjs.io/form-library/documentation/api-reference/matrix-table-with-dropdown-list#rows"><code>rows</code></a> array).</td>
      </tr>
      <tr>
        <td rowspan="2" style="vertical-align:middle"><a href="/form-library/documentation/api-reference/dynamic-panel-model">Dynamic Panel</a></td>
        <td><code>{panel.questionname}</code></td>
        <td>Accesses a question within the same panel.</td>
      </tr>
      <tr>
        <td style="vertical-align:middle"><code>{parentPanel.questionname}</code></td>
        <td>Accesses a question within a parent Dynamic Panel.<br>Applies when one Dynamic Panel question is nested in another.</td>
      </tr>
      <tr>
        <td><a href="/form-library/documentation/customize-question-types/create-composite-question-types">Composite questions</a></td>
        <td><code>{composite.questionname}</code></td>
        <td>Accesses a question within the same composite question.</td>
      </tr>
    </tbody>
  </table>
</div>

In this demo, the `row` prefix is used to calculate totals in each matrix row and enable or disable the Quantity column cells based on a condition. Refer to the `json.js` file for code examples.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "calculatedValues": [
    {
      "name": "totalExpr",
      "expression": "sumInArray({orders}, 'total')"
    },
    {
      "name": "10%DiscountExpr",
      "expression": "{totalExpr} - ({totalExpr} * 0.1)"
    },
    {
      "name": "15%DiscountExpr",
      "expression": "{totalExpr} - ({totalExpr} * 0.15)"
    },
    {
      "name": "20%DiscountExpr",
      "expression": "{totalExpr} - ({totalExpr} * 0.2)"
    }
  ],
  "elements": [
    {
      "type": "matrixdynamic",
      "name": "orders",
      "minRowCount": 1,
      "titleLocation": "hidden",
      "addRowText": "Add new item",
      "columns": [
        {
          "name": "id",
          "title": "Id",
          "cellType": "expression",
          "expression": "{rowIndex}",
          "visible": false
        },
        {
          "name": "phoneModel",
          "title": "Phone model",
          "isRequired": true,
          "cellType": "dropdown",
          "choices": [
            { "text": "iPhone 15 Pro Max, 256GB", "value": "iPhone15ProMax-256", "price": 1199 },
            { "text": "iPhone 15 Pro Max, 512GB", "value": "iPhone15ProMax-512", "price": 1399 },
            { "text": "iPhone 15 Pro Max, 1TB", "value": "iPhone15ProMax-1024", "price": 1599 },
            { "text": "iPhone 15 Pro, 128GB", "value": "iPhone15Pro-128", "price": 999 },
            { "text": "iPhone 15 Pro, 256GB", "value": "iPhone15Pro-256", "price": 1099 },
            { "text": "iPhone 15 Pro, 512GB", "value": "iPhone15Pro-512", "price": 1299 },
            { "text": "iPhone 15 Pro, 1TB", "value": "iPhone15Pro-1024", "price": 1499 },
            { "text": "iPhone 15 Plus, 128GB", "value": "iPhone15Plus-128", "price": 899 },
            { "text": "iPhone 15 Plus, 256GB", "value": "iPhone15Plus-256", "price": 999 },
            { "text": "iPhone 15 Plus, 512GB", "value": "iPhone15Plus-512", "price": 1199 },
            { "text": "iPhone 15, 128GB", "value": "iPhone15-128", "price": 799 },
            { "text": "iPhone 15, 256GB", "value": "iPhone15-256", "price": 899 },
            { "text": "iPhone 15, 512GB", "value": "iPhone15-512", "price": 1099 },
            { "text": "iPhone 14 Pro Max, 256GB", "value": "iPhone14ProMax-256", "price": 1099 },
            { "text": "iPhone 14 Pro Max, 512GB", "value": "iPhone14ProMax-512", "price": 1299 },
            { "text": "iPhone 14 Pro Max, 1TB", "value": "iPhone14ProMax-1024", "price": 1499 },
            { "text": "iPhone 14 Pro, 128GB", "value": "iPhone14Pro-128", "price": 899 },
            { "text": "iPhone 14 Pro, 256GB", "value": "iPhone14Pro-256", "price": 999 },
            { "text": "iPhone 14 Pro, 512GB", "value": "iPhone14Pro-512", "price": 1199 },
            { "text": "iPhone 14 Pro, 1TB", "value": "iPhone14Pro-1024", "price": 1399 },
            { "text": "iPhone 14 Plus, 128GB", "value": "iPhone14Plus-128", "price": 799 },
            { "text": "iPhone 14 Plus, 256GB", "value": "iPhone14Plus-256", "price": 899 },
            { "text": "iPhone 14 Plus, 512GB", "value": "iPhone14Plus-512", "price": 1099 },
            { "text": "iPhone 14, 128GB", "value": "iPhone14-128", "price": 699 },
            { "text": "iPhone 14, 256GB", "value": "iPhone14-256", "price": 799 },
            { "text": "iPhone 14, 512GB", "value": "iPhone14-512", "price": 999 }
          ]
        },
        {
          "name": "price",
          "title": "Price",
          "cellType": "expression",
          "expression": "getItemPrice('phoneModel')",
          "displayStyle": "currency"
        },
        {
          "name": "quantity",
          "title": "Quantity",
          "isRequired": true,
          "cellType": "text",
          "inputType": "number",
          "min": 1,
          "max": 100,
          "defaultValue": 1,
          "textUpdateMode": "onTyping",
          "enableIf": "{row.phoneModel} notempty"
        },
        {
          "name": "total",
          "title": "Total",
          "cellType": "expression",
          "expression": "{row.quantity} * {row.price}",
          "displayStyle": "currency"
        }
      ]
    },
    {
      "type": "html",
      "name": "totalHtml",
      "html": "<p style=\"text-align:right\"><b>Total: <ins>${totalExpr}</ins></b></p>",
      "visibleIf": "{totalExpr} < 3000"
    },
    {
      "type": "html",
      "name": "10%DiscountHtml",
      "html": "<p style=\"text-align:right\"><b>Total: <del>${totalExpr}</del> <ins>${10%DiscountExpr}</ins></b> (-10%)</p>",
      "visibleIf": "{totalExpr} >= 3000 and {totalExpr} < 5000"
    },
    {
      "type": "html",
      "name": "15%DiscountHtml",
      "html": "<p style=\"text-align:right\"><b>Total: <del>${totalExpr}</del> <ins>${15%DiscountExpr}</ins></b> (-15%)</p>",
      "visibleIf": "{totalExpr} >= 5000 and {totalExpr} < 7000"
    },
    {
      "type": "html",
      "name": "20%DiscountHtml",
      "html": "<p style=\"text-align:right\"><b>Total: <del>${totalExpr}</del> <ins>${20%DiscountExpr}</ins></b> (-20%)</p>",
      "visibleIf": "{totalExpr} >= 7000"
    },
    {
      "type": "multipletext",
      "name": "contactDetails",
      "title": "Enter contact details",
      "items": [
        { "name": "name", "title": "Full name", "isRequired": true },
        { "name": "address", "title": "Shipping address", "isRequired": true },
        { "name": "phone", "title": "Phone", "isRequired": true },
        { "name": "email", "title": "Email", "isRequired": true, "validators": [{ "type": "email" }] }
      ],
      "itemTitleWidth": "90px",
      "visibleIf": "sumInArray({orders}, 'total') > 0"
    },
    {
      "type": "boolean",
      "name": "subscribed",
      "displayMode": "checkbox",
      "title": "I agree to receive weekly newsletters",
      "defaultValue": true,
      "visibleIf": "{contactDetails.email} notempty"
    }
  ],
  "completedHtml": "<h4>Thank you for your order!</h4><p>Your order will be shipped within 5 days. We'll send you an email with order details shortly.</p>"
};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";
import { Serializer, registerFunction } from "survey-core";

// Add the `price` property to choice options
Serializer.addProperty("itemvalue", "price:number");

// A custom function that returns a selected item's price
const getItemPrice = function (params) {
    // `this.row` is available only within matrix cells
    const question = this.row ? this.row.getQuestionByColumnName(params[0]) : null;
    if (!question) return 0;
    const selectedItem = question.selectedItem;
    // Return 0 if a user haven't selected an item yet
    return selectedItem ? selectedItem.price : 0;
};
registerFunction({ name: "getItemPrice", func: getItemPrice });

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.data = {
            "orders": [{
                "id": 1,
                "phoneModel": "iPhone15ProMax-1024",
                "quantity": 1,
            }, {
                "id": 2,
                "phoneModel": "iPhone15-256",
                "quantity": 2,
            }, {
                "id": 3,
                "phoneModel": "iPhone14Pro-512",
                "quantity": 2,
            }],
            "subscribed": true
        };
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/vanillajs.md)


---
title: Complex Questions in Expressions
product: Form Library
description: Learn how to access values of individual items in multiple textboxes or specific matrix cells and use them in expressions, form branching, and visibility rules for any follow-up questions. Try out a live JavaScript form builder demo with a step-by-step implementation guide.
framework: React
source: https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Complex Questions in Expressions (React)

Complex questions can contain more than one value. Such questions include Single-, Multi-Select, and Dynamic Matrices, Dynamic Panels, and Multiple Textboxes questions. This example demonstrates how to access different values within complex questions.

To access a value from outside a complex question, use the question's name and the name of its element (item, row, column) to which the value belongs:

<div class="v2-class---doc-table-container">
  <table class="v2-class---doc-table-container__table">
    <thead>
      <tr>
        <th>Question Type</th>
        <th>Syntax</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <td><a href="/form-library/documentation/api-reference/multiple-text-entry-question-model">Multiple Textboxes</a></td>
        <td><code>{questionname.itemname}</code></td>
      </tr>
      <tr>
        <td><a href="/form-library/documentation/api-reference/matrix-table-question-model">Single-Select Matrix</a></td>
        <td><code>{questionname.rowname}</code></td>
      </tr>
      <tr>
        <td rowspan="2" style="vertical-align:middle"><a href="/form-library/documentation/api-reference/matrix-table-with-dropdown-list">Multi-Select Matrix</a></td>
        <td><code>{questionname.rowname.columnname}</code></td>
      </tr>
      <tr>
        <td><code>{questionname-total.columnname}</code> (accesses a cell in the total row)</td>
      </tr>
    </tbody>
  </table>
</div>

This demo shows a [Multiple Textboxes](/form-library/documentation/api-reference/multiple-text-entry-question-model) question that asks users to enter contact details, including an email address. Under this question, the form displays an "I agree to receive newsletters" checkbox, which is visible only if an email address is provided. This checkbox is a [Yes/No (Boolean)](/form-library/documentation/api-reference/boolean-question-model) question. Its [`visibleIf`](/form-library/documentation/api-reference/boolean-question-model#visibleIf) expression accesses the email address input field of the Multiple Textboxes question using the notation from the table above.

To access a value (question or cell) within a [Dynamic Panel](/form-library/documentation/api-reference/dynamic-panel-model) or [Dynamic Matrix](/form-library/documentation/api-reference/dynamic-matrix-table-question-model) from outside, use a zero-based index:

| Question Type                                                          | Syntax                                     |
| ---------------------------------------------------------------------- | ------------------------------------------ |
| [Dynamic Panel](/form-library/documentation/api-reference/dynamic-panel-model)   | `{dynamicpanelname[index].questionname}`   |
| [Dynamic Matrix](/form-library/documentation/api-reference/dynamic-matrix-table-question-model) | `{dynamicmatrixname[rowindex].columnname}` |

To access a cell or question from inside a matrix, panel, or composite question, use the `row`, `panel`, `parentPanel`, and `composite` prefixes:

<div class="v2-class---doc-table-container">
  <table class="v2-class---doc-table-container__table">
    <thead>
      <tr>
        <th>Question Type</th>
        <th>Syntax</th>
        <th>Action</th>
      </tr>
    </thead>
    <tbody>
      <tr>
        <td rowspan="3" style="vertical-align:middle"><a href="/form-library/documentation/api-reference/matrix-table-question-model">Single-Select Matrix</a>, <a href="/form-library/documentation/api-reference/matrix-table-with-dropdown-list">Multi-Select Matrix</a>, <a href="/form-library/documentation/api-reference/dynamic-matrix-table-question-model">Dynamic Matrix</a></td>
        <td><code>{row.columnname}</code></td>
        <td>Accesses a cell in the same row.</td>
      </tr>
      <tr>
        <td style="vertical-align:middle"><code>{rowName}</code></td>
        <td>Accesses the row name (the <code>value</code> property within objects in the <a href="https://surveyjs.io/form-library/documentation/api-reference/matrix-table-with-dropdown-list#rows"><code>rows</code></a> array). Use this placeholder if you need to distinguish between matrix rows.</td>
      </tr>
      <tr>
        <td style="vertical-align:middle"><code>{rowTitle}</code></td>
        <td>Accesses the row title (the <code>text</code> property within objects in the <a href="https://surveyjs.io/form-library/documentation/api-reference/matrix-table-with-dropdown-list#rows"><code>rows</code></a> array).</td>
      </tr>
      <tr>
        <td rowspan="2" style="vertical-align:middle"><a href="/form-library/documentation/api-reference/dynamic-panel-model">Dynamic Panel</a></td>
        <td><code>{panel.questionname}</code></td>
        <td>Accesses a question within the same panel.</td>
      </tr>
      <tr>
        <td style="vertical-align:middle"><code>{parentPanel.questionname}</code></td>
        <td>Accesses a question within a parent Dynamic Panel.<br>Applies when one Dynamic Panel question is nested in another.</td>
      </tr>
      <tr>
        <td><a href="/form-library/documentation/customize-question-types/create-composite-question-types">Composite questions</a></td>
        <td><code>{composite.questionname}</code></td>
        <td>Accesses a question within the same composite question.</td>
      </tr>
    </tbody>
  </table>
</div>

In this demo, the `row` prefix is used to calculate totals in each matrix row and enable or disable the Quantity column cells based on a condition. Refer to the `json.js` file for code examples.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { Serializer, registerFunction } from "survey-core";

// Add the `price` property to choice options
Serializer.addProperty("itemvalue", "price:number");

// A custom function that returns a selected item's price
const getItemPrice = function (params) {
    // `this.row` is available only within matrix cells
    const question = this.row ? this.row.getQuestionByColumnName(params[0]) : null;
    if (!question) return 0;
    const selectedItem = question.selectedItem;
    // Return 0 if a user haven't selected an item yet
    return selectedItem ? selectedItem.price : 0;
};
registerFunction({ name: "getItemPrice", func: getItemPrice });

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    survey.data = {
        "orders": [{
            "id": 1,
            "phoneModel": "iPhone15ProMax-1024",
            "quantity": 1,
        }, {
            "id": 2,
            "phoneModel": "iPhone15-256",
            "quantity": 2,
        }, {
            "id": 3,
            "phoneModel": "iPhone14Pro-512",
            "quantity": 2,
        }],
        "subscribed": true
    };
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "calculatedValues": [
    {
      "name": "totalExpr",
      "expression": "sumInArray({orders}, 'total')"
    },
    {
      "name": "10%DiscountExpr",
      "expression": "{totalExpr} - ({totalExpr} * 0.1)"
    },
    {
      "name": "15%DiscountExpr",
      "expression": "{totalExpr} - ({totalExpr} * 0.15)"
    },
    {
      "name": "20%DiscountExpr",
      "expression": "{totalExpr} - ({totalExpr} * 0.2)"
    }
  ],
  "elements": [
    {
      "type": "matrixdynamic",
      "name": "orders",
      "minRowCount": 1,
      "titleLocation": "hidden",
      "addRowText": "Add new item",
      "columns": [
        {
          "name": "id",
          "title": "Id",
          "cellType": "expression",
          "expression": "{rowIndex}",
          "visible": false
        },
        {
          "name": "phoneModel",
          "title": "Phone model",
          "isRequired": true,
          "cellType": "dropdown",
          "choices": [
            { "text": "iPhone 15 Pro Max, 256GB", "value": "iPhone15ProMax-256", "price": 1199 },
            { "text": "iPhone 15 Pro Max, 512GB", "value": "iPhone15ProMax-512", "price": 1399 },
            { "text": "iPhone 15 Pro Max, 1TB", "value": "iPhone15ProMax-1024", "price": 1599 },
            { "text": "iPhone 15 Pro, 128GB", "value": "iPhone15Pro-128", "price": 999 },
            { "text": "iPhone 15 Pro, 256GB", "value": "iPhone15Pro-256", "price": 1099 },
            { "text": "iPhone 15 Pro, 512GB", "value": "iPhone15Pro-512", "price": 1299 },
            { "text": "iPhone 15 Pro, 1TB", "value": "iPhone15Pro-1024", "price": 1499 },
            { "text": "iPhone 15 Plus, 128GB", "value": "iPhone15Plus-128", "price": 899 },
            { "text": "iPhone 15 Plus, 256GB", "value": "iPhone15Plus-256", "price": 999 },
            { "text": "iPhone 15 Plus, 512GB", "value": "iPhone15Plus-512", "price": 1199 },
            { "text": "iPhone 15, 128GB", "value": "iPhone15-128", "price": 799 },
            { "text": "iPhone 15, 256GB", "value": "iPhone15-256", "price": 899 },
            { "text": "iPhone 15, 512GB", "value": "iPhone15-512", "price": 1099 },
            { "text": "iPhone 14 Pro Max, 256GB", "value": "iPhone14ProMax-256", "price": 1099 },
            { "text": "iPhone 14 Pro Max, 512GB", "value": "iPhone14ProMax-512", "price": 1299 },
            { "text": "iPhone 14 Pro Max, 1TB", "value": "iPhone14ProMax-1024", "price": 1499 },
            { "text": "iPhone 14 Pro, 128GB", "value": "iPhone14Pro-128", "price": 899 },
            { "text": "iPhone 14 Pro, 256GB", "value": "iPhone14Pro-256", "price": 999 },
            { "text": "iPhone 14 Pro, 512GB", "value": "iPhone14Pro-512", "price": 1199 },
            { "text": "iPhone 14 Pro, 1TB", "value": "iPhone14Pro-1024", "price": 1399 },
            { "text": "iPhone 14 Plus, 128GB", "value": "iPhone14Plus-128", "price": 799 },
            { "text": "iPhone 14 Plus, 256GB", "value": "iPhone14Plus-256", "price": 899 },
            { "text": "iPhone 14 Plus, 512GB", "value": "iPhone14Plus-512", "price": 1099 },
            { "text": "iPhone 14, 128GB", "value": "iPhone14-128", "price": 699 },
            { "text": "iPhone 14, 256GB", "value": "iPhone14-256", "price": 799 },
            { "text": "iPhone 14, 512GB", "value": "iPhone14-512", "price": 999 }
          ]
        },
        {
          "name": "price",
          "title": "Price",
          "cellType": "expression",
          "expression": "getItemPrice('phoneModel')",
          "displayStyle": "currency"
        },
        {
          "name": "quantity",
          "title": "Quantity",
          "isRequired": true,
          "cellType": "text",
          "inputType": "number",
          "min": 1,
          "max": 100,
          "defaultValue": 1,
          "textUpdateMode": "onTyping",
          "enableIf": "{row.phoneModel} notempty"
        },
        {
          "name": "total",
          "title": "Total",
          "cellType": "expression",
          "expression": "{row.quantity} * {row.price}",
          "displayStyle": "currency"
        }
      ]
    },
    {
      "type": "html",
      "name": "totalHtml",
      "html": "<p style=\"text-align:right\"><b>Total: <ins>${totalExpr}</ins></b></p>",
      "visibleIf": "{totalExpr} < 3000"
    },
    {
      "type": "html",
      "name": "10%DiscountHtml",
      "html": "<p style=\"text-align:right\"><b>Total: <del>${totalExpr}</del> <ins>${10%DiscountExpr}</ins></b> (-10%)</p>",
      "visibleIf": "{totalExpr} >= 3000 and {totalExpr} < 5000"
    },
    {
      "type": "html",
      "name": "15%DiscountHtml",
      "html": "<p style=\"text-align:right\"><b>Total: <del>${totalExpr}</del> <ins>${15%DiscountExpr}</ins></b> (-15%)</p>",
      "visibleIf": "{totalExpr} >= 5000 and {totalExpr} < 7000"
    },
    {
      "type": "html",
      "name": "20%DiscountHtml",
      "html": "<p style=\"text-align:right\"><b>Total: <del>${totalExpr}</del> <ins>${20%DiscountExpr}</ins></b> (-20%)</p>",
      "visibleIf": "{totalExpr} >= 7000"
    },
    {
      "type": "multipletext",
      "name": "contactDetails",
      "title": "Enter contact details",
      "items": [
        { "name": "name", "title": "Full name", "isRequired": true },
        { "name": "address", "title": "Shipping address", "isRequired": true },
        { "name": "phone", "title": "Phone", "isRequired": true },
        { "name": "email", "title": "Email", "isRequired": true, "validators": [{ "type": "email" }] }
      ],
      "itemTitleWidth": "90px",
      "visibleIf": "sumInArray({orders}, 'total') > 0"
    },
    {
      "type": "boolean",
      "name": "subscribed",
      "displayMode": "checkbox",
      "title": "I agree to receive weekly newsletters",
      "defaultValue": true,
      "visibleIf": "{contactDetails.email} notempty"
    }
  ],
  "completedHtml": "<h4>Thank you for your order!</h4><p>Your order will be shipped within 5 days. We'll send you an email with order details shortly.</p>"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/use-and-represent-complex-questions-in-expressions/vanillajs.md)
